package cn.wise.sc.consume.business.controller;


import cn.wise.sc.consume.business.entity.SysCouponDetail;
import cn.wise.sc.consume.business.entity.SysUserCoupon;
import cn.wise.sc.consume.business.mapper.SysUserMapper;
import cn.wise.sc.consume.business.service.ISysCouponDetailService;
import cn.wise.sc.consume.business.wrapper.WrapMapper;
import cn.wise.sc.consume.business.wrapper.Wrapper;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author ztw
 * @since 2020-07-27
 */
@RestController
@RequestMapping("/business/sys-user")
public class SysUserController {
    private static final Logger log = LoggerFactory.getLogger("SysUserController");

    @Resource
    private SysUserMapper sysUserMapper;

    @Autowired
    private ISysCouponDetailService couponDetailService;

    @ApiOperation(value = "个人优惠卷列表")
    @GetMapping("SysUserCoupon/{detailId}")
    public Wrapper getCouponDetailById(@PathVariable("detailId") Long detailId){
        try {
            List<SysUserCoupon> byDetailId = sysUserMapper.getByDetailId(detailId);
            if(byDetailId == null){
                return WrapMapper.wrap(400,"信息错误");
            }
            return WrapMapper.wrap(200,"成功",byDetailId);
        }catch (Exception e){
            log.debug("用户优惠券详情{}",e);
        }
        return WrapMapper.error("失败");
    }
}

