package cn.wise.sc.consume.business.service.impl;

import cn.wise.sc.consume.business.entity.SysCouponDetail;
import cn.wise.sc.consume.business.entity.SysUserCoupon;
import cn.wise.sc.consume.business.mapper.SysCouponDetailMapper;
import cn.wise.sc.consume.business.mapper.SysUserCouponMapper;
import cn.wise.sc.consume.business.model.ReceivedAppListVO;
import cn.wise.sc.consume.business.service.ISysCouponDetailService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author ztw
 * @since 2020-07-31
 */
@Service
public class SysCouponDetailServiceImpl extends ServiceImpl<SysCouponDetailMapper, SysCouponDetail> implements ISysCouponDetailService {

	@Autowired
	private SysCouponDetailMapper couponDetailMapper;
	@Autowired
	private SysUserCouponMapper userCouponMapper;


	@Override
	public List<ReceivedAppListVO> getReceivedList(String coridc,String usridc) {
		List<ReceivedAppListVO>  list = couponDetailMapper.getReceivedList(coridc, usridc);
		return list;
	}


	@Override
	public List<ReceivedAppListVO> getAllReceivedList(String usridc) {
		List<ReceivedAppListVO>  list = couponDetailMapper.getAllReceivedList(usridc);
		return list;
	}

	@Override
	public List<ReceivedAppListVO> getAllReceivedListSE(String coridc,String usridc) {
		List<ReceivedAppListVO>  list = couponDetailMapper.getAllReceivedListSE(coridc, usridc);
		return list;
	}

	@Override
	public List<ReceivedAppListVO> getOverdueList(String usridc) {
		List<ReceivedAppListVO>  list = couponDetailMapper.getOverdueList(usridc);
		return list;
	}

	@Override
	public List<ReceivedAppListVO> getOverdueListSE(String coridc,String usridc) {
		List<ReceivedAppListVO>  list = couponDetailMapper.getOverdueListSE(coridc, usridc);
		return list;
	}


	/**
	 * 筛选过期优惠券，将优惠券详情表：未领取的状态改成已过期。
	 * 优惠券领取表-未使用的状态改为已过期
	 */
	@Async
	@Override
	public void beVerdue(){
		List<SysCouponDetail> verdueList = couponDetailMapper.getVerdueList();
		if(verdueList!= null && verdueList.size()>0){
			for(SysCouponDetail couponDetail : verdueList){
				couponDetail.setIsReceive(2);
				couponDetailMapper.updateById(couponDetail);
			}
		}
		List<SysUserCoupon> verdueList2 = userCouponMapper.getVerdueList();
		if(verdueList2!= null && verdueList2.size()>0){
			for(SysUserCoupon userCoupon : verdueList2){
				userCoupon.setIsUse(2);
				userCouponMapper.updateById(userCoupon);
			}
		}
	}












}
